OpenTTD Source: CargoResolverObject Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Data Fields
CargoResolverObject Struct Reference

Resolver of cargo. More...

Inheritance diagram for CargoResolverObject:

## Public Member Functions
| CargoResolverObject (const CargoSpec *cs, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Constructor of the cargo resolver.
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for.
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor.
ResolverResult | DoResolve ()
int32_t | GetRegister (uint i) const
| Gets the value of a so-called newgrf "register".
void | SetRegister (uint i, int32_t value)
| Sets the value of a so-called newgrf "register".
template<class TSpriteGroup >
const TSpriteGroup * | Resolve ()
| Resolve SpriteGroup.
void | ResolveRerandomisation ()
| Resolve bits to be rerandomised.
CallbackResult | ResolveCallback (std::span< int32_t > regs100)
| Resolve callback.
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup &group) const
| Get the real sprites of the grf.
virtual ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, uint8_t relative=0)
| Get a resolver for the scope.
uint32_t | GetWaitingRandomTriggers () const
| Used by RandomizedSpriteGroup: Triggers for rerandomisation.
void | AddUsedRandomTriggers (uint32_t triggers)
| Used by RandomizedSpriteGroup: Consume triggers.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.

## Data Fields
const CargoSpec * | cargospec
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback {}
| Callback being resolved.
uint32_t | callback_param1 = 0
| First parameter (var 10) of the callback.
uint32_t | callback_param2 = 0
| Second parameter (var 18) of the callback.
uint32_t | last_value = 0
| Result of most recent DeterministicSpriteGroup (including procedure calls)
std::array< uint32_t, VSG_END > | reseed
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile = nullptr
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup = nullptr
| Root SpriteGroup to use for resolving.

## Additional Inherited Members
Protected Attributes inherited from ResolverObject
uint32_t | waiting_random_triggers = 0
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_random_triggers = 0
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)

## Detailed Description

Resolver of cargo.

Definition at line 18 of file newgrf_cargo.cpp.

## Constructor & Destructor Documentation

## ◆ CargoResolverObject()

CargoResolverObject::CargoResolverObject | ( | const CargoSpec * | cs,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | callback_param1 = `0`,
|  | uint32_t | callback_param2 = `0`
| ) |  |

Constructor of the cargo resolver.

Parameters

  cs | Cargo being resolved.
  callback | Callback ID.
  callback_param1 | First parameter (var 10) of the callback.
  callback_param2 | Second parameter (var 18) of the callback.

Definition at line 44 of file newgrf_cargo.cpp.

References ResolverObject::root_spritegroup.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t CargoResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 32 of file newgrf_cargo.cpp.

References CargoSpec::label.

## ◆ GetFeature()

GrfSpecFeature CargoResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 27 of file newgrf_cargo.cpp.

## Field Documentation

## ◆ cargospec

const CargoSpec* CargoResolverObject::cargospec

Definition at line 19 of file newgrf_cargo.cpp.

The documentation for this struct was generated from the following file:

- src/newgrf_cargo.cpp